using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace _41072
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			this.gridDataBoundGrid1.DataSource = this.GetTable();
			this.gridDataBoundGrid1.PrepareViewStyleInfo += new GridPrepareViewStyleInfoEventHandler(gridDataBoundGrid1_PrepareViewStyleInfo);

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(0, 0);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(400, 222);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 1;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			this.gridDataBoundGrid1.Resize += new System.EventHandler(this.gridDataBoundGrid1_Resize);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(400, 222);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable GetTable()
		{
			DataTable dt = new DataTable();
			for(int i = 0; i<5;i++)
			{
				DataColumn col = new DataColumn(string.Format("COL{0}",i));
				dt.Columns.Add(col);
			}

			for(int i = 0; i<2500;i++)
			{
				DataRow row = dt.NewRow();
				for(int j = 0; j<5;j++)
					row[j] = string.Format("{0}, {1}",i,j);
				dt.Rows.Add(row);
			}

			return dt;
		}

		int fillCol = 0;
		private void Form1_Load(object sender, System.EventArgs e)
		{	
			this.gridDataBoundGrid1.Model.Cols.Hidden[0] = true;			
			this.gridDataBoundGrid1.Model.ColWidths[2] = 150;
			this.gridDataBoundGrid1.Model[1,1].Text ="<--------";
			this.gridDataBoundGrid1.Model[1,2].Text ="row header col is hidden";
			this.gridDataBoundGrid1.Binder.EndEdit();
			fillCol = 5;
			this.gridDataBoundGrid1.Model.CellModels.Add("LinkLabelCell",new LinkLabelCellModel(this.gridDataBoundGrid1.Model));

			this.gridDataBoundGrid1.Model.QueryColWidth += new GridRowColSizeEventHandler(Model_QueryColWidth);
			this.gridDataBoundGrid1.Model.ColWidthsChanged += new GridRowColSizeChangedEventHandler(Model_ColWidthsChanged);
		}


		
		private void gridDataBoundGrid1_PrepareViewStyleInfo(object sender, GridPrepareViewStyleInfoEventArgs e)
		{
			if(e.ColIndex == 2 && e.RowIndex == 2)
			{
				e.Style.CellType = "LinkLabelCell";
				e.Style.Text = "Syncfusion, Inc.";
				e.Style.Tag = "http://www.syncfusion.com";
			}

		}

		private void Model_QueryColWidth(object sender, GridRowColSizeEventArgs e)
		{
			if (fillCol > 0 && e.Index == this.gridDataBoundGrid1.Model.Cols.FrozenCount + fillCol)
			{
				int leftPiece = this.gridDataBoundGrid1.Model.ColWidths.GetTotal(0, this.gridDataBoundGrid1.Model.Cols.FrozenCount + fillCol - 1);
				int rightPiece = this.gridDataBoundGrid1.Model.ColWidths.GetTotal(this.gridDataBoundGrid1.Model.Cols.FrozenCount + fillCol + 1, this.gridDataBoundGrid1.Model.ColCount);
				e.Size = (((this.gridDataBoundGrid1.ClientSize.Width - leftPiece - rightPiece) < 0) ? 4 : (this.gridDataBoundGrid1.ClientSize.Width - leftPiece - rightPiece));
				e.Handled = true;
			}
		}

		private void Model_ColWidthsChanged(object sender, GridRowColSizeChangedEventArgs e)
		{
			this.gridDataBoundGrid1.Invalidate();
		}

		private void gridDataBoundGrid1_Resize(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.Invalidate();
		}
	}
}
